Author Topic: RPi1 broken - DO NOT UPGRADE! - Partial solution found.  (Read 618 times)

phenigma

  • LinuxMCE God
  • ****
  • Posts: 1719
    • View Profile
RPi1 broken - DO NOT UPGRADE! - Partial solution found.
« on: September 21, 2015, 07:20:37 pm »
Hey all,

Just a heads up that we've found an issue recently with RPi1 PXE boots.  The Raspberry Pi foundation recently pushed a new kernel which is using device tree blobs on the raspberrypi 1.  This has broken the u-boot booting process as it was designed and built prior to device tree support on the raspberry pi.

Do NOT create a new diskless image as the new kernel will be there and will prevent booting after announcement to the router.

Thanks.

J.
« Last Edit: September 23, 2015, 10:20:22 pm by phenigma »

phenigma

  • LinuxMCE God
  • ****
  • Posts: 1719
    • View Profile
Re: RPi1 broken - DO NOT UPGRADE!
« Reply #1 on: September 22, 2015, 04:37:20 am »
I am sad to announce the discontinuation of the RPi1 as a PXE booting device.  The RaspberryPi foundation has released a new kernel which depends on device trees.  The boot process that I spent months hacking on to get working no longer functions.  If someone wishes to continue hacking on u-boot I am happy to help them do so.  As of now the RPi1 is not intended to be supported.

RPi2 setup and booting is unaffected.

J.

phenigma

  • LinuxMCE God
  • ****
  • Posts: 1719
    • View Profile
Re: RPi1 broken - DO NOT UPGRADE!
« Reply #2 on: September 23, 2015, 10:19:48 pm »
If you have not yet upgraded your RPi1 there is a solution to keep you active.  Place the following information in a file named "/etc/apt/preferences"

Code: [Select]
Package: raspberrypi-bootloader
Pin: version 1.20150421-1*
Pin-Priority: 1001

This will prevent the kernel upgrade that has killed the u-boot based boot system the RPi1 has been using for nearly 2 years and permit you to still use apt-get upgrade.

Do NOT attempt to create new diskless images for the rpi1, they will not boot the new kernels after announcing to the router.

It turns out the Raspbian based RPi2 images will also boot the RPi1, so the RPi1 can have a new life beyond u-boot.  I *highly* recommend upgrading to the RPi2 as the user experience is greatly improved.

J.
« Last Edit: September 23, 2015, 10:22:08 pm by phenigma »

phenigma

  • LinuxMCE God
  • ****
  • Posts: 1719
    • View Profile
Re: RPi1 broken - DO NOT UPGRADE! - Partial solution found.
« Reply #3 on: September 25, 2015, 02:08:46 am »
A more complete preferences file looks like this:
Code: [Select]
Package: raspberrypi-bootloader
Pin: version 1.20150421-1*
Pin-Priority: 1001

Package: libraspberrypi0
Pin: version 1.20150421-1*
Pin-Priority: 1001

Package: libraspberrypi-bin
Pin: version 1.20150421-1*
Pin-Priority: 1001

Package: libraspberrypi-dev
Pin: version 1.20150421-1*
Pin-Priority: 1001

Package: libraspberrypi-doc
Pin: version 1.20150421-1*
Pin-Priority: 1001

I'm looking at getting the required pkgs into the repo so that we can continue to support pxe booting rpi1s, at least for the time being.

J.